use strict ; 
open ( FILE , "</tmp/netstat" ) ; 

my @netstat_all = <FILE> ;

close FILE ; 
my %port_connection ; 
my $base_oid = ".1.3.6.1.3.4" ; 
my %snmp_port ; 
my $port_num = 1 ; 
my $req ;
my $regex = qr/(?:[:]{2}ffff[:]+)?([\d.]+:\d+)\s+(?:[:]{2}ffff[:]+)?([\d.]+:\d+)\s+([\w_\d]+)/ ;
process () ; 

my $mode = shift(@ARGV);
if ( $mode eq "-g" ) {
        $req = shift(@ARGV);
            getoid($req);
        }
        elsif ( $mode eq "-n" ) {
          $req = shift(@ARGV);
          my $next = getnextoid($req);
          getoid($next);
        } 
        else {     
          $req = $mode;
          getoid($req);
        }
}
                            }



sub process {
    foreach my $connection ( @netstat_all )  {
        $connection  =~  /$regex/ ; 
        my $local_con = $1 ; 
        my $stat = $3 ; 
        $local_con =~ /[\d.]+:(\d+)/ ;
        my $port = $1 ; 
        if ( $port <= 1024 && $stat ) {
            $port_connection{$port} = {} if ( ! ( defined $port_connection{$port} ) ) ; 
            $port_connection{$port}{$stat} = 0 if ( ! ( defined $port_connection{$port}{$stat} ) ) ; 
            $port_connection{$port}{$stat} += 1 ; 

        }
    }
    foreach my $port ( keys %port_connection ) {
        $snmp_port{"$base_oid.1.$port_num"} = $port_num  ; #index 
        $snmp_port{"$base_oid.2.$port_num"} = $port ; #index 
        $snmp_port{"$base_oid.3.$port_num"} = $port_connection{$port}{"SYN_SENT"}  || 0 ; 
        $snmp_port{"$base_oid.4.$port_num"} = $port_connection{$port}{"SYN_RECV"} || 0 ; 
        $snmp_port{"$base_oid.5.$port_num"} = $port_connection{$port}{"FIN_WAIT1"} || 0 ;  
        $snmp_port{"$base_oid.6.$port_num"} = $port_connection{$port}{"TIME_WAIT"}   || 0 ; 
        $snmp_port{"$base_oid.7.$port_num"} = $port_connection{$port}{"CLOSE_WAIT"}  || 0 ;  
        $snmp_port{"$base_oid.8.$port_num"} = $port_connection{$port}{"FIN_WAIT2"}   || 0 ;
        $snmp_port{"$base_oid.9.$port_num"} = $port_connection{$port}{"LAST_ACK"} || 0 ;  
        $snmp_port{"$base_oid.10.$port_num"} = $port_connection{$port}{"CLOSING"}  || 0 ;
        $snmp_port{"$base_oid.11.$port_num"} = $port_connection{$port}{"ESTABLISHED"} || 0 ;  
        $port_num++ ; 
    }
}


    


sub getoid {
    my $oid = shift(@_);
    if ( $oid =~ /^$base_oid\.(\d+)\.(\d+).*/ && exists( $snmp_port{$oid} ) ) {
        print $oid. "\n";
        if ( $1 == 1 ) {
            print "integer\n";
        }
        else {
            print "string\n";
        }

        print $snmp_port{$oid} . "\n";
    }
}

sub getnextoid {
    my $first_oid = shift(@_);
    my $next_oid  = '';
    my $count_id;
    my $index;

    if ( $first_oid =~ /$base_oid\.(\d+)\.(\d+).*/ ) {
        if ( $2 + 1 >= $port_num ) {
            $count_id = $1 + 1;
            $index    = 1;
        }
        else {
            $index    = $2 + 1;
            $count_id = $1;
        }
        $next_oid = "$base_oid.$count_id.$index";
    }
    elsif ( $first_oid =~ /$base_oid\.(\d+).*/ ) {
        $next_oid = "$base_oid.$1.1";
    }
    elsif ( $first_oid eq $base_oid ) {
        $next_oid = "$base_oid.1.1";
    }
    return $next_oid;
}
  
